package ISDVMIEncode;
# %Z%%M%------- %I%- %W% %G% %U% 

use strict;
use warnings;
require Exporter;

our @ISA=qw(Exporter);
our @EXPORT=qw(decode encode crypt_passwd);
our @VERSION=1.0;

# XOR a string with 0x5f
sub ibmxor
{
    my ($string) = @_;
    my @chars;

    @chars = unpack('C*', $string);
    for my $cnt (0 .. $#chars) { $chars[$cnt] ^= 0x5f; };

    return pack('C*', @chars);
};

sub decode
{
    my ($string) = @_;
    my $len;
    my $tempstring;
    my @chars;

    # basic uudecode, string must not exceed 86 bytes
    # remove padding
    $string     =~ tr#A-Za-z0-9+/##cd;
    $string     =~ tr#A-Za-z0-9+/# -_#;
    $len        =  pack("c", 32 + 0.75*length($string));
    $tempstring =  unpack("u", $len . $string);

    return ibmxor($tempstring);
};

sub encode
{
    my $string = $_[0];

    my $res;
    my $padding;

    $string     = ibmxor($string);

    $res        = pack("u", $string);

    # Remove first character of each line, remove newlines
    $res        =~ s/^.//mg;
    $res        =~ s/\n//g;
    $res        =~ tr|` -_|AA-Za-z0-9+/|;               # `

    # fix padding at the end
    $padding    =   (3 - length($string) % 3) % 3;
    $res        =~  s/.{$padding}$/'=' x $padding/e if $padding;


    return $res;
}

# crypt the password, just like what Linux do in /etc/shadow
sub crypt_passwd
{
    my $passwd = $_[0];
    my @chars=('0'..'9', 'a'..'z', 'A'..'Z', "./");
    my $salt ='$6$';
    foreach (0 .. 15){
        $salt .= $chars [rand (@chars)];
    }
    $salt .='$';
    my $encrypted_passwd=crypt ($passwd, $salt);
    return $encrypted_passwd;
}

