#!/usr/bin/perl -w
#

use warnings;
use strict;
use Getopt::Long;


my %options = ();
my $ROUTEFILE = "/etc/sysconfig/network/routes";
my $HOSTNAMEFILE = "/etc/HOSTNAME";
my $HOSTFILE = "/etc/hosts";


if (! (GetOptions (\%options, 'hostname=s', 'domain=s','hostnameip=s', 'ipv4gateway=s','device=s', 'ipv6gateway=s'))) {
    exit (1); 
}

# host name setting
if (defined $options{'hostname'}){
    open FILE, "> $HOSTNAMEFILE";
    if(defined $options{'domain'}){
         print FILE "$options{'hostname'}.$options{'domain'}\n";
	 `hostname $options{'hostname'}.$options{'domain'}`;
    }else{
    	 print FILE "$options{'hostname'}\n";
         `hostname $options{'hostname'}`;
    }
    close FILE;
    if(defined $options{'hostnameip'}){
	 open FILE, "> $HOSTFILE";
         if(defined $options{'domain'}){
               print FILE "$options{'hostnameip'}\t$options{'hostname'}.$options{'domain'}\t$options{'hostname'}\n";
         }else{
	       print FILE "$options{'hostnameip'}\t$options{'hostname'}\n";     
	 }
         close FILE;
    }
}

# gateway setting
my $gateway_conf="";
if (defined $options{'ipv4gateway'}){
    $gateway_conf.="default\t$options{'ipv4gateway'}\t0.0.0.0\t";
    if(defined $options{'device'}){
         $gateway_conf.=$options{'device'};
    } 
    $gateway_conf.="\n";
}
if (defined $options{'ipv6gateway'}){
    $gateway_conf.="default\t$options{'ipv6gateway'}\t-\t-\n";
}

if (! $gateway_conf eq ""){
    open FILE, "> $ROUTEFILE";
    print FILE $gateway_conf;
    close FILE;
}

