# Licensed Materials - Property of IBM
# 
# 09N6996
#
# (C) Copyright IBM Corp. 2009, 2011 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp. 
#
#####################################################
# This file contains all the common declarations
# It will also load any common code
#####################################################

if [ -z "$CMD_DIR" ]; then
	echo "Internal error: CMD_DIR must be set."
	exit 1
fi
#
RPATH=/usr/bin:/bin/:/sbin/:/opt/ibm/director/bin:/usr/smrshbin/:
export PATH=$RPATH:$PATH

## Configuration Section ############
DFT_DIRECTOR_INSTALL=/opt/ibm/director
### -------------------------------------------------------
# Call set_director_dirs() to set these directories
INSTALL_DIR=        # The Director install directory
JREBIN_DIR=			# The JRE bin directory (for keytool)
SMHA_DIR=           # The HA directory in the install path
SMHA_CONFIGDIR=     # The config directory in the HA path where the SSL key material is stored
SMHA_SCRIPTS=       # Where the HA scripts are located
SMHA_INCLUDE=       # Where the HA includes are located
SMHA_CFG_FILE=      # The full path to the HA Config file
BACKUP_DIR=         # Where we backup Director's data
AGENTMANAGER_DIR=   # Where the Agent Mgr files are located
CASMANAGER_DIR=     # Where the CAS Agent files are located
LOG_DIR=            # The log directory
LOG=                # The log file
CFG_STATE_FILE=     # The configuration state

### -------------------------------------------------------
export CT_MANAGEMENT_SCOPE=2

NONVMI_CFG=0

SMHA_CFG_FILENAME=smhacfg.prop

# Debug & logging settings
# To turn debug on, set it to ON
DEBUG=O
DEBUG_PGM_ONLY=
#DEBUG_PGM_ONLY=smhatsadir.sh
DEBUG_TSA=ON
LOG_VERBOSE=verbose

# Mount point for the non-appliance
HA_MOUNTPOINT=/mnt/smha

# DB Settings
DB2HAICU=0
DB2INST=db2inst1
DB2ADM=db2iadm1
DB2DB=IBMDIR01
DB2PART=0
eval DB2INST_HOME=~${DB2INST}
DB2DATA_DIR=$DB2INST_HOME/$DB2INST
DB2SQL_DIR=$DB2INST_HOME/sqllib

# Quorum Values
NET_QUORUM=netq
Y_QUORUM=yq

# Static TSA status values
#0=unknown,1=online,2=offline,3=failed offline,4=stuck online,5=pending online,6=stuck online	
TSA_UNKNOWN=0
TSA_ONLINE=1
TSA_OFFLINE=2 
TSA_FAILED_OFFLINE=3
TSA_STUCK_ONLINE=4
TSA_PENDING_ONLINE=5
TSA_PENDING_OFFLINE=6

RSCT_NODEINFO_FILE=/var/ct/cfg/ctsec.nodeinfo
RSCT_NODEID_FILE=/etc/ct_node_id

RSCT_CRIT_RSRC_PROTECT__HARD_RESET=1
RSCT_CRIT_RSRC_PROTECT__OFF=7


TSA_DOMAIN=director
TSA_RETRY_COUNT=3 
STORAGE_RG=storage-rg
STORAGE_RG_PRIORITY=15
DRBD_RG=drbd-rg
DRBD_RG_PRIORITY=30
DIRECTOR_RG=director-rg
DIRECTOR_RG_PRIORITY=60
NFS_RSRC_NAME=nfs
DIRECTOR_RSRC_NAME=director
DIRECTOR_MONITOR_SCRIPT=tsa/smhatsadir.sh
#ADDRGMBR_ORDER="O,Failback"
ADDRGMBR_ORDER="O"

DB2_RG=db2_${DB2INST}_${DB2PART}-rg
DB2_RG_PRIORITY=45
DB2_DB_RSRC_NAME=db2_${DB2INST}_${DB2PART}-rs
DB2_MON_CMD_PERIOD=60
DB2_MON_CMD_TIMEOUT=60
DB2_MON_START_TIMEOUT=360
DB2_MON_STOP_TIMEOUT=360
DB2_MIRROR_NAME=mirror0

CIM_RG=cim-rg
CIM_RSRC_NAME=cim
#CIM_RG_PRIORITY=45
CIM_MONITOR_SCRIPT=tsa/smhatsacim.sh
CIM_MON_CMD_PERIOD=20
CIM_MON_CMD_TIMEOUT=60
CIM_MON_START_TIMEOUT=120
CIM_MON_STOP_TIMEOUT=120


CLEANUP_COMMAND_SCRIPT=tsa/smhatsaclnup.sh
CLEANUP_COMMAND_TIMEOUT=120

DIR_MON_CMD_PERIOD=10
DIR_MON_CMD_TIMEOUT=60
#DIR_MON_START_TIMEOUT=3000
DIR_MON_START_TIMEOUT=2400
DIR_MON_STOP_TIMEOUT=600
ALIAS_RSRC_NAME=alias
ALIAS6_RSRC_NAME=aliasv6

NTP_RG=ntp-rg
NTP_RSRC_NAME=ntp
NTP_MONITOR_SCRIPT=tsa/smhatsantp.sh
NTP_MON_CMD_PERIOD=30
NTP_MON_CMD_TIMEOUT=20
NTP_MON_START_TIMEOUT=20
NTP_MON_STOP_TIMEOUT=20

DHCP_RG=dhcp-rg
DHCP6_RG=dhcp6-rg
DHCP_RSRC_NAME=dhcp
DHCP6_RSRC_NAME=dhcp6
DHCP_MONITOR_SCRIPT=tsa/smhatsadhcp.sh
DHCP_MON_CMD_PERIOD=60
DHCP_MON_CMD_TIMEOUT=20
DHCP_MON_START_TIMEOUT=120
DHCP_MON_STOP_TIMEOUT=120
DHCP_MIRROR_NAME=mirror0


HADM_RG=hadaemon-rg
HADM_RSRC_NAME=hadaemon
HADM_MONITOR_SCRIPT=tsa/smhatsadm.sh
HADM_MON_CMD_PERIOD=20
HADM_MON_CMD_TIMEOUT=20
HADM_MON_START_TIMEOUT=20
HADM_MON_STOP_TIMEOUT=20

HAMQ_RSRC_NAME=hamq
HAMQ_MONITOR_SCRIPT=tsa/smhatsamq.sh
HAMQ_MON_CMD_PERIOD=20
HAMQ_MON_CMD_TIMEOUT=20
HAMQ_MON_START_TIMEOUT=20
HAMQ_MON_STOP_TIMEOUT=20

# Change this to 1 to use drbd equivalences rather than locks
DRBD_EQU=1

GETMIRROR_CMD=/opt/ibm/director/vmi/bin/getmirror
GETMIRROR_DEPENDENCY_CMD=/opt/ibm/director/vmi/bin/getmirrordep

DRBDB_RSRC_NAME=drbdb
DRBDP_RSRC_NAME=drbdp
DRBDS_RSRC_NAME=drbds
DRBDM_RSRC_NAME=drbdm
DB2MIRROR_RSRC_NAME=${DRBDM_RSRC_NAME}-${DB2_MIRROR_NAME}
DHCPMIRROR_RSRC_NAME=${DRBDM_RSRC_NAME}-${DHCP_MIRROR_NAME}
DRBD_RSRC_NAME_SEARCH=drbd%
DRBD_MONITOR_SCRIPT=tsa/smhatsadrbd.sh
DRBD_MON_CMD_PERIOD=30
DRBD_MON_CMD_TIMEOUT=60
DRBD_MON_START_TIMEOUT=300
DRBD_MON_STOP_TIMEOUT=300
DRBD_CONF=/etc/drbd.conf
DRBD_INVALIDATE_FILE=drbd-invalid

UPDATESLIB_RSRC_NAME=updateslib
UPDATESLIBMIRROR_RSRC_NAME=${DRBDM_RSRC_NAME}-${UPDATESLIB_RSRC_NAME}


# Director Values
DIR_SHUTDOWN_DELAY=10

# Config State
CFG_STATE_NONE=NO_CONFIG
CFG_STATE_NODE=NODE_CONFIGURED
CFG_STATE_TSA=TSA_MODEL_STARTED
CFG_STATE_FINISHED=FINISHED
CFG_STATE_FILE_NAME=smhastate

HA_TAR_FILE_NAME_PREFIX=smha

### Functions ######################

# Setup the HA path and filenames
set_director_dirs () {
        
    # Find the install directory.  Assume the scripts are always run from the install path
    if [ -z "$INSTALL_DIR" ]; then
        INSTALL_DIR=${CMD_DIR%/ha/bin*}
    fi
        
    SMHA_DIR=$INSTALL_DIR/ha
    SMHA_SCRIPTS=$SMHA_DIR/bin
    SMHA_INCLUDE=$SMHA_SCRIPTS/include
    SMHA_CONFIGDIR=$SMHA_DIR/config
    SMHA_CFG_FILE=$SMHA_CONFIGDIR/$SMHA_CFG_FILENAME
    BACKUP_DIR=$SMHA_DIR/data-bkup
    AGENTMANAGER_DIR=$INSTALL_DIR/lwi/runtime/agentmanager
    CASMANAGER_DIR=$AGENTMANAGER_DIR/eclipse/plugins/com.ibm.tivoli.cas.manager
    AGENT_DIR=$INSTALL_DIR/agent
    CFG_STATE_FILE=$SMHA_DIR/$CFG_STATE_FILE_NAME
    JREBIN_DIR=$INSTALL_DIR/jre/bin
    
    LOG_DIR=$SMHA_DIR/logs
    LOG=$LOG_DIR/smha.log
    
	HA_DIRECTOR_DIR=$HA_MOUNTPOINT/director
	HA_AGNTMGR_DIR=$HA_MOUNTPOINT/agentmanager
	HA_DB2DIR=$HA_DIRECTOR_DIR/db2
	
	USMIKERNEL_PROPS=$INSTALL_DIR/lwi/conf/overrides/USMIKernel.properties
	AUTOMATION_FLAGFILE=$SMHA_CONFIGDIR/.smhaEnableAutomation
    SYNCCONFIG_FLAGFILE=$SMHA_CONFIGDIR/.smhaTSASyncConf
    REFRESH_MANAGEMENTIP_FLAGFILE=$SMHA_CONFIGDIR/.refreshManagementIP
    EXCLUDE_PEER_FLAGFILE=$SMHA_CONFIGDIR/.smhaPeerNodeExcluded
    SHUTDOWN_HALT_FLAGFILE=$SMHA_CONFIGDIR/.smhaNodeHalt
    STOP_MAINT_FLAGFILE=$SMHA_CONFIGDIR/.smhaStopMaint
    DM_CONF=$SMHA_CONFIGDIR/smhadm.conf
    CFG_STATUS_FILE=$SMHA_CONFIGDIR/.cfgstatus
    BROKER_KS=$SMHA_CONFIGDIR/broker.ks
    
    SYSLOG_TRIP_FILE=$SMHA_CONFIGDIR/.syslog.stopped
    SYSLOG_STOPPED_DHCP=$SMHA_CONFIGDIR/.syslog.stopped.dhcp
    
}

# Pass in the mandatory common code to load
load_common_code () {
    local code_file=${1}
    if [ -e $code_file ]; then
        source $code_file
    else
        echo "Internal error: Common code not found: $code_file"
        exit 1
    fi
    
}

# the following function is to work around a TSA bug in the chrg command.
# It may return an error message indicating a failure, but the exit code is 0.
# This function will verify that the expected change has occurred before returning
# a good exit code. The function will make 3 attempts, 5 seconds apart
#
# The function takes three or five arguments, depending on the first argument value.
#
#   Arg1 = -o
#   Arg2 = online | offline     (not case sensitive, unlike chrg command)
#   Arg3 = resource group name
#
#   Arg1 = -l
#   Arg2 = None | Collocated    (not case sensitive, unlike chrg command)
#   Arg3 = resource group name
#
#   Arg1 = -u
#   Arg2 = a | d
#   Arg3 = -x
#   Arg4 = node name
#   Arg5 = resource group name
#
# The caller is expected to capture stdout from this function, which includes stderr from chrg
#
# Function Exit status:  0  success
#                        99 could not effect change after three attempts
#                        125 missing required argument
#                        N  any other value is from chrg

call_tsa_chrg_o_l_u() {
    local lsArg=
    local ExpectedOutput=
    local RGname=
    local MatchNode=
    local tsa_result=
    local rc=
    local lsoutput=

    if [ $# -lt 3 ]
    then
        # The caller has a bug; must be at least three args
        return 125
    fi

    case $1 in
        -o )
            lsArg=NominalState
            if [[ $2 = "online" ]]
            then
                ExpectedOutput=0
            else
                ExpectedOutput=1
            fi
            RGname=$3
        ;;

        -l )
            lsArg=MemberLocation
            if [[ $2 = "None" ]]
            then
                ExpectedOutput=0
            else
                ExpectedOutput=1
            fi
            RGname=$3
        ;;

        -u )
            if [ $# -ne 5 ]
            then
                # The caller has a bug; must be five args
                return 125
            fi

            if [ $2 = "a" ]
            then
                ExpectedRC=0
            else
                ExpectedRC=1
            fi
            MatchNode=$4
            RGname=$5

        ;;

        * )
            # The caller has a bug; 1st arg must be of of -o, -l or -u
            return 125

        ;;
    esac

    for (( i=3; i > 0; i-- ))
    do
        tsa_result=$(chrg $@ 2>&1)
        rc=$?

        if [[ $rc -ne 0 ]]
        then
            if (( i > 1 ))
            then
                sleep 5
                continue
            fi

            echo "$tsa_result"
            return $rc
        fi

        if [[ -n $ExpectedOutput ]]
        then
            lsoutput=$(LC_ALL=C lsrsrc-api -s "IBM.ResourceGroup::Name == \"$RGname\"::${lsArg}" 2> /dev/null)
            if [[ $lsoutput = $ExpectedOutput ]]
            then
                echo "$tsa_result"
                return 0
            fi
        else
            # cannot use lsrsrc-api, since that returns a resource handle in ExcludedList

            LC_ALL=C lsrg -g $RGname | grep "ExcludedList.*${MatchNode}" > /dev/null 2>&1; rc=$?
            if [[ $ExpectedRC = $rc ]]
            then
                echo "$tsa_result"
                return 0
            fi
        fi

        if (( i > 1 ))
        then
            sleep 5
        fi
    done

    echo "$tsa_result"
    return 99
}

# the following function is to work around a TSA bug in the samctrl command.
# It may return an error message indicating a failure, but the exit code is 0.
# This function will verify that the expected change has occurred before returning
# a good exit code. The function will make 3 attempts, 5 seconds apart
#
# The function takes one or two arguments.
#
#   Arg1 = the option value to be passed with the -M flag of samctrl
#   Arg2 = if present, the option value to be passed with the -r flag of samctrl
#
# The caller is expected to capture stdout from this function, which includes stderr from samctrl
#
# Function Exit status:  0  success
#                        99 could not effect change after three attempts
#                        125 missing required argument
#                        N  any other value is from samctrl

call_tsa_samctrl_M_r() {
    local MFlagArg=
    local rFlagOpt=
    local lsArg=
    local ExpectedOutput=
    local tsa_result=
    local rc=
    local lsoutput=

    if [ $# -lt 1 ]
    then
        # The caller has a bug; must be at least one arg
        return 125
    fi

    MFlagArg=$1
    if [[ $MFlagArg = "T" ]]
    then
        ExpectedOutput=0
    else
        ExpectedOutput=1
    fi

    if [ $# -gt 1 ]
    then
        ExpectedOutput=${ExpectedOutput}::$2

        rFlagOpt="-r $2"
        lsArg="::RetryCount"
    fi

    # echo "MFlagArg=$MFlagArg  rFlagOpt=$rFlagOpt  ExpectedOutput=$ExpectedOutput"

    for (( i=3; i > 0; i-- ))
    do
        tsa_result=$(samctrl -M $MFlagArg $rFlagOpt 2>&1)
        rc=$?

        if [[ $rc -ne 0 ]]
        then
            if (( i > 1 ))
            then
                sleep 5
                continue
            fi

            echo "$tsa_result"
            return $rc
        fi

        lsoutput=$(LC_ALL=C lsrsrc-api -c IBM.CHARMControl::::Automation${lsArg} 2> /dev/null)
        if [[ $lsoutput = $ExpectedOutput ]]
        then
            echo "$tsa_result"
            return 0
        fi

        if (( i > 1 ))
        then
            sleep 5
        fi
    done

    echo "$tsa_result"
    return 99
}

export TEXTDOMAINDIR=/usr/share/locale
export TEXTDOMAIN=smhacmd
. /usr/bin/gettext.sh

### Main Code ######################

HOST=`hostname -s 2>/dev/null`
if [ $? != 0 ]; then
    HOST=`hostname`
fi

set_director_dirs

load_common_code $SMHA_INCLUDE/smhacomcode.sh

mk_log_dir
gen_log_id

#debug "$PROGNAME COMMON PATH:$PATH"

