# Licensed Materials - Property of IBM
# 
# 09N6996
#
# (C) Copyright IBM Corp. 2009, 2010 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.

run_init () {

    TWG_DIRECTORY_ROOT="/opt/ibm/director"
    TWG_DIRECTORY_BIN="$TWG_DIRECTORY_ROOT/bin"
    TWG_DIRECTORY_DATA="$TWG_DIRECTORY_ROOT/data"
    TWG_DIRECTORY_PRODDATA="$TWG_DIRECTORY_ROOT/proddata"
    USMI_CAS_PLUGIN=`dirname \`find /opt/ibm/director/lwi/runtime/USMi*/eclipse/plugins/com\.ibm\.director\.core\.kernel* -name casclientusmiimpl.jar | sort | tail -n 1\``
     
    CAS_SYSPROPS="-Dtwg.directory.proddata=$TWG_DIRECTORY_PRODDATA"
    CAS_SYSPROPS="$CAS_SYSPROPS -Dtwg.directory.root=$TWG_DIRECTORY_ROOT"
    CAS_SYSPROPS="$CAS_SYSPROPS -Dagent.directory.root=$TWG_DIRECTORY_ROOT/agent"

    SMHA_CLASS=com.ibm.vmi.ha.Initializer
    SM_JAVA=/opt/ibm/director/jre/bin/java
    
    sshPath=`find /opt/ibm/director/lwi/runtime/USMi*/eclipse/plugins/com\.ibm\.net\.ssh* -name ssh\.jar`
    SM_CLASSPATH=${sshPath}
    
    remoteaccessPath=`find /opt/ibm/director/lwi/runtime/USMi*/eclipse/plugins/com\.ibm\.tivoli\.remoteaccess* -name remoteaccess.jar`
    SM_CLASSPATH=$SM_CLASSPATH:${remoteaccessPath}
        
    SM_CLASSPATH=$SM_CLASSPATH:/opt/ibm/director/lwi/runtime/messaging/eclipse/plugins/org.apache.activemq_5.2.0/activemq-all-5.2.0.jar
    SM_CLASSPATH=$SM_CLASSPATH:/opt/ibm/director/lwi/runtime/core/eclipse/plugins/org.apache.commons.logging_1.0.4.20091117-1800.jar
    SM_CLASSPATH=$SM_CLASSPATH:/opt/ibm/director/ha/lib/classes
    SM_CLASSPATH=$SM_CLASSPATH:/opt/ibm/director/ha/lib/smhadm.jar
    SM_CLASSPATH=$SM_CLASSPATH:/opt/ibm/director/lwi/runtime/ApplianceMgmt/eclipse/plugins/com.ibm.vmi.cmdapi.util_1.0.0/CmdAPI.jar
    SM_CLASSPATH=$SM_CLASSPATH:$USMI_CAS_PLUGIN/casclientusmiimpl.jar
    SM_CLASSPATH=$SM_CLASSPATH:$TWG_DIRECTORY_ROOT/lwi/lib/passutils.jar
    SM_CLASSPATH=$SM_CLASSPATH:$USMI_CAS_PLUGIN/classes/slp.jar
    SM_CLASSPATH=$SM_CLASSPATH:/opt/ibm/director/lwi/runtime/rest/eclipse/plugins/com.ibm.json_1.0.1.0.jar
    
    
    SM_LOGGING=-Djava.util.logging.config.file=/opt/ibm/director/ha/logs/init_logging.properties
    
    if [ -f /opt/ibm/director/ha/debug ]; then
        DEBUG_ARGS="-Dsmhawait=60000 -Xdebug -Xnoagent -Xrunjdwp:transport=dt_socket,server=y,address=8000,suspend=n"
        VERBOSE="-verbose:class"
    fi
    
    # Start the Initializer
    export CLASSPATH=$SM_CLASSPATH
    $SM_JAVA $VERBOSE $DEBUG_ARGS $SM_LOGGING $CAS_SYSPROPS $SMHA_CLASS $*

    return $?
    
}

send_conf_parms () {
    
        local rc=0
        # Send the config over to the other node
        # This will do the secondary setup work
        # setup the parameters to send
        local parms
        # Send over our node name
        parms="node $HOST"
        if [ -n "$dhcp" ]; then
            parms="$parms dhcp $dhcp"
        fi
        if [ -n "$local_replication_address" ]; then
            parms="$parms local-replication-address $local_replication_address"
        fi
        if [ -n "$remote_replication_address" ]; then
            parms="$parms remote-replication-address $remote_replication_address"
        fi
        if [ -n "$agent_manager_address" ]; then
            parms="$parms agent-manager-address $agent_manager_address"
        fi
        if [ -n "$network_quorum" ]; then
            parms="$parms network-quorum $network_quorum"
        fi
        # Handle multiple network alias
        local i
        for i in {1..10}
        do
            # try this name
            MULTI_PARM_VAR=network_alias__${i}
            # if we can dereference it and the length is non zero then it's set
            if [ -n "${!MULTI_PARM_VAR}" ]; then
                parms="$parms network-alias ${!MULTI_PARM_VAR}"
            fi 
        done
        # Handle multiple network alias6
        local i
        for i in {1..10}
        do
            # try this name
            MULTI_PARM_VAR=network_alias6__${i}
            # if we can dereference it and the length is non zero then it's set
            if [ -n "${!MULTI_PARM_VAR}" ]; then
                parms="$parms network-alias6 ${!MULTI_PARM_VAR}"
            fi 
        done
                        
        debug "calling init conf with parms:$parms"
        run_init "conf"  $parms
        rc=$?
        
        return $rc
    
}

