# Licensed Materials - Property of IBM
# 
# 09N6996
#
# (C) Copyright IBM Corp. 2009, 2010 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.

#SMHA_PLUGIN_MODEL_DIR_BASE=/opt/ibm/director/ha/bin/tsa/m.
SMHA_PLUGIN_MODEL_DIR_BASE=/opt/ibm/director/ha/plugins/tsa/m.

#
# Parameters:
#   level:  The mirror level to invoke. (like, 0,1,2,3,etc)
#   method: The method to run. Either "create", or "delete"
#
run_plugins () {
    local level=$1
    local method=$2

    # Export variables needed by the plugin
    export node

    local srchdir=${SMHA_PLUGIN_MODEL_DIR_BASE}${level}

    files=`ls $srchdir`
	if [ -n "$files" ]; then
        for f in $files
        do
            if [ -x $srchdir/$f ]; then
                debug "Calling: $f $method"
                $srchdir/$f $method 
            fi
        done
	
	fi

}

#SMHA_PLUGIN_DRBD_DIR_BASE=/opt/ibm/director/ha/bin/drbd/
SMHA_PLUGIN_DRBD_DIR_BASE=/opt/ibm/director/ha/plugins/drbd/

#
# Parameters:
#   method: The method to run. Either "stop", "start", "bindmounts"
#           Which means to stop or start any services that may hold open files on the resource
#           bindmount = means the next step will be to process bind mounts for this resource.
#   resource: The mount point
#
run_drbd_plugins () {
    local method=${1}
    local mountpt=${2}

    # Export variables needed by the plugin
    export node

    local srchdir=${SMHA_PLUGIN_DRBD_DIR_BASE}

    files=`ls $srchdir`
    if [ -n "$files" ]; then
        for f in $files
        do
            if [ -x $srchdir/$f ]; then
                debug "Calling: $f $method $mountpt"
                $srchdir/$f $method $mountpt 
                debug "Returning from call to: $f $method $mountpt"
            fi
        done
    
    fi

}

SMHA_PLUGIN_CONF_DIR_BASE=/opt/ibm/director/ha/plugins/conf/

#
# Parameters:
#   operation: Either "conf" or "unconf"
#   state: Either "begin", or "end"
#
run_conf_plugins () {
    local operation=${1}
    local state=${2}

    # Export variables needed by the plugin
    export node

    local srchdir=${SMHA_PLUGIN_CONF_DIR_BASE}

    files=`ls $srchdir`
    if [ -n "$files" ]; then
        for f in $files
        do
            if [ -x $srchdir/$f ]; then
                debug "Calling: $f $operation $state"
                $srchdir/$f $operation $state 
            fi
        done
    
    fi

}

