#!/bin/bash
# Licensed Materials - Property of IBM
# 
# 09N6996
#
# (C) Copyright IBM Corp. 2009, 2010 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.

PATH=/usr/bin:$PATH
PROGNAME=$(basename $0)
PROGPATH=$(dirname $0)

INSTALL_DIR=/opt/ibm/director
CMD_DIR=$INSTALL_DIR/ha/bin/priv
COMMON_CODE=/opt/ibm/director/ha/bin/include/smhacommon.sh

if [ -f $COMMON_CODE ]; then
    source $COMMON_CODE
else
    echo "$PROGNAME:Common code not found."
    exit 1
fi
#############################################################

load_common_code $INSTALL_DIR/ha/bin/include/smhaplugin.sh


###################################
## Functions                     ##
###################################


###################################
## Main code                     ##
###################################

plugin=${1}
shift 1

case $plugin in 
    tsa)
        run_plugins $*
    ;;
    drbd)
        run_drbd_plugins $*
    ;;    
    conf)
        run_conf_plugins $*
    ;;
esac


