#!/bin/bash
# Licensed Materials - Property of IBM
# 
# 09N6996
#
# (C) Copyright IBM Corp. 2009, 2010 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
#

HTML_FROM_LOCATION=/opt/ibm/director/ha/html
HTML_TO_LOCATION=/home/cons/ha/html

export TEXTDOMAINDIR=/usr/share/locale
export TEXTDOMAIN=smhacmd
. /usr/bin/gettext.sh

if [ ! -d $HTML_TO_LOCATION ]
then
  mkdir -p $HTML_TO_LOCATION
fi

cp -rf $HTML_FROM_LOCATION/* $HTML_TO_LOCATION

#I'm changing this so sed can write the file
chmod +w $HTML_TO_LOCATION/*.html

PASSIVE_NODE_TITLE="`eval_gettext "IBM Systems Director Passive Node"`"
PASSIVE_NODE_TEXT="`eval_gettext "High Availability Passive Node"`"
PASSIVE_NODE_COPYRIGHT="`eval_gettext "Licensed Materials - Property of IBM Corp. \&#x00a9; IBM Corporation and other(s) 2008, 2010. IBM is a registered trademark of the IBM Corporation, in the United States, other countries, or both."`"

#replace the text in the file
sed -i "s|PASSIVE_NODE_TITLE|$PASSIVE_NODE_TITLE|g" $HTML_TO_LOCATION/passiveNode.html
sed -i "s|PASSIVE_NODE_TEXT|$PASSIVE_NODE_TEXT|g" $HTML_TO_LOCATION/passiveNode.html
sed -i "s|PASSIVE_NODE_COPYRIGHT|$PASSIVE_NODE_COPYRIGHT|g" $HTML_TO_LOCATION/passiveNode.html
