# Licensed Materials - Property of IBM
# 
# 09N6996
#
# (C) Copyright IBM Corp. 2009, 2010 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.

PROGNAME=$(basename $0)
PROGPATH=$(dirname $0)
#### Use a special path for TSA monitoring scripts
PATH=/bin:/usr/bin:/sbin:/usr/sbin:/usr/sbin/rsct/bin
export PATH

#### Standard code to find an pull in all sm common code ####
INSTALL_DIR=/opt/ibm/director
CMD_DIR=$INSTALL_DIR/ha/bin/tsa
COMMON_CODE=/opt/ibm/director/ha/bin/include/smhacommon.sh

if [ -f $COMMON_CODE ]; then
    source $COMMON_CODE
else
    echo "$PROGNAME:Common code not found."
    exit 1
fi
#############################################################



#################################################
#  Functions
#################################################
send_arp () {
	
	local gw=`LC_ALL=C /usr/smrshbin/lsnetcfg -n -F gateway`
	local ips=`LC_ALL=C lsrsrc -s "ResourceType=1" IBM.ServiceIP IPAddress | grep IPAddress | cut -d'"' -f2`
	local ip=
	for ip in $ips
	do
		local arp_out=`arping  -c 1 -s $ip  $gw`
		debug "arp out:$arp_out"
	done
		
}


#################################################
#  Main code
#################################################
ARP_FILE=$SMHA_CONFIGDIR/.arping
RC=$TSA_UNKNOWN
  
Action=${1}

case ${Action} in
start)
    debug "Arp start"
    send_arp
    touch $ARP_FILE
    RC=0
    ;;
stop)
    debug "Arp stop"
    rm -f $ARP_FILE
    RC=0
    ;;

status)
    debug "Arp status"
    
    if [ -e $ARP_FILE ]; then
        RC=${TSA_ONLINE}
    else
        RC=${TSA_OFFLINE}
    fi
    ;;
esac
record_tsa_action $Action arp $RC
exit $RC
