# Licensed Materials - Property of IBM
# 
# 09N6996
#
# (C) Copyright IBM Corp. 2009, 2010 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.

PROGNAME=$(basename $0)
PROGPATH=$(dirname $0)
#### Use a special path for TSA monitoring scripts
PATH=/bin:/usr/bin:/sbin:/usr/sbin:/usr/sbin/rsct/bin
export PATH

#### Standard code to find an pull in all sm common code ####
INSTALL_DIR=/opt/ibm/director
CMD_DIR=$INSTALL_DIR/ha/bin/tsa
COMMON_CODE=/opt/ibm/director/ha/bin/include/smhacommon.sh

if [ -f $COMMON_CODE ]; then
    source $COMMON_CODE
else
    echo "$PROGNAME:Common code not found."
    exit 1
fi
#############################################################

RC=$TSA_UNKNOWN  

Action=${1}

case ${Action} in
start)
    
    /etc/init.d/smhamq start
    sm_sys_log "HA MQ started"
    RC=0
    ;;
stop)
    /etc/init.d/smhamq stop
    
    sm_sys_log "HA MQ stopped"
    RC=0
    ;;

status)
    /etc/init.d/smhamq status
    statusrc=$?
    case $statusrc in
        0) #Active
            RC=${TSA_ONLINE}
            ;;
        *) #Inactive
            RC=${TSA_OFFLINE}
            ;;
    esac
    ;;
esac
#debug_tsa "$PROGNAME $Action: rc=$RC"
record_tsa_action $Action apachemq $RC
exit $RC
