#!/bin/bash
# Licensed Materials - Property of IBM
# 
# 09N6996
#
# (C) Copyright IBM Corp. 2009, 2010 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.

PROGNAME=$(basename $0)
PROGPATH=$(dirname $0)
#### Use a special path for TSA monitoring scripts
PATH=/bin:/usr/bin:/sbin:/usr/sbin:/usr/sbin/rsct/bin
export PATH

#### Standard code to find an pull in all sm common code ####
# Use the specified path to this command, then working directory, then path
PATH=$PROGPATH:`pwd`:$PATH
CMDFINDER=which
CMD_DIR=`$CMDFINDER $PROGNAME`
CMD_DIR=`dirname $CMD_DIR`

COMMON_CODE=$CMD_DIR/../include/smhacommon.sh

if [ -f $COMMON_CODE ]; then
    source $COMMON_CODE
else
    echo "$PROGNAME:Common code not found."
    exit 1
fi
#############################################################

NTP_INIT_CMD=/etc/init.d/ntp
NTP_BIN_CMD=/usr/sbin/ntpd
NTP_PID_FILE=/var/run/ntp/ntpd.pid

RC=$TSA_UNKNOWN  

Action=${1}

case ${Action} in
start)
    
    $NTP_INIT_CMD start
    sm_sys_log "NTP started"
    RC=0
    ;;
stop)
    $NTP_INIT_CMD stop
    
    sm_sys_log "NTP stopped"
    RC=0
    ;;

status)
    checkproc -p ${NTP_PID_FILE} ${NTP_BIN_CMD}
    statusrc=$?
#    debug "checkproc ntpd returned:$statusrc"
    case $statusrc in
        0) #Active
            RC=${TSA_ONLINE}
            ;;
        *) #Inactive
            RC=${TSA_OFFLINE}
            ;;
    esac
    ;;
esac
record_tsa_action $Action ntp $RC
exit $RC
