#!/bin/bash
# Licensed Materials - Property of IBM
# 
# 09N6996
#
# (C) Copyright IBM Corp. 2010, 2010 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.

PATH=/usr/bin:$PATH
PROGNAME=$(basename $0)
PROGPATH=$(dirname $0)

INSTALL_DIR=/opt/ibm/director
CMD_DIR=$INSTALL_DIR/ha/bin/priv
COMMON_CODE=/opt/ibm/director/ha/bin/include/smhacommon.sh

if [ -f $COMMON_CODE ]; then
    source $COMMON_CODE
else
    echo "$PROGNAME:Common code not found."
    exit 1
fi
#############################################################
load_common_code $INSTALL_DIR/ha/bin/include/smhadrbd.sh


RSCT_BKUP=/var/ct.backup
UPGRADE_LOG_FILE=/opt/ibm/director/vmi/upgrade/save/log/upgrade_deferred.log

hdl_upgrade () {
    
    if [ -e $RSCT_BKUP ]; then
    
        # Stop rsct
        /usr/bin/rmcctrl -z
        
        debug "ctrestore start"
        local rst_out=`/usr/sbin/rsct/bin/ctrestore 2>&1`
        rst_rc=$?
        debug "ctrestore rc:$rst_rc output:$rst_out"
        
        if [ $rst_rc -ne 0 ]; then
            echo -e "$PROGNAME: ctrestore failed" >>$UPGRADE_LOG_FILE 2>&1
            exit $rst_rc
        fi
        rm -rf $RSCT_BKUP
        
        # Startup rsct
        #/usr/bin/rmcctrl -s >/dev/null 2>&1
    fi
    
    touch $DRBD_UPGRADE_FLAG
    
    # It takes a while for RSCT configuration to kick in
    sleep 60
    
}

###################################
## Main code                     ##
###################################
debug "Running deferred upgrade script"

hdl_upgrade

exit 0
